/* $Id: conf.c,v 1.4 2001/02/19 17:56:43 mpalczew Exp $
 *** finder applet
 *** Copyright (C) 2000 Mike Palczewski mpalczew@u.washington.edu
 *** 
 *** This program is free software; you can redistribute it and/or
 *** modify it under the terms of the GNU General Public License
 *** as published by the Free Software Foundation; either version 2
 *** of the License, or (at your option) any later version.
 *** 
 *** This program is distributed in the hope that it will be useful,
 *** but WITHOUT ANY WARRANTY; without even the implied warranty of
 *** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *** GNU General Public License for more details.
 *** 
 *** You should have received a copy of the GNU General Public License
 *** along with this program; if not, write to the Free Software
 *** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 *** 02111-1307, USA.
 ***/

#include <gnome.h>
#include "conf.h"

conf *get_conf()
{
	conf *l;
	l = g_malloc(sizeof(conf));
	
	l->width = gnome_config_get_int("/finder_applet/main/width=200");
	l->icon_size =
	    gnome_config_get_int("/finder_applet/main/icon_size=30");
	l->shadow_type =
	    gnome_config_get_int("/finder_applet/main/shadowtype=4");
	return l;
}

void set_conf(conf * config)
{
	gnome_config_set_int("/finder_applet/main/width", config->width);
	gnome_config_set_int("/finder_applet/main/icon_size",
			     config->icon_size);
	gnome_config_set_int("/finder_applet/main/shadowtype",
			     config->shadow_type);
	gnome_config_sync();
}

void free_conf(conf * config)
{
	g_free(config);
}
