/* $Id: properties.c,v 1.6 2001/02/19 21:47:05 mpalczew Exp $
 * finder_applet
 ** Copyright (C) 2000 Mike Palczewski mpalczew@u.washington.edu
 ** 
 ** This program is free software; you can redistribute it and/or
 ** modify it under the terms of the GNU General Public License
 ** as published by the Free Software Foundation; either version 2
 ** of the License, or (at your option) any later version.
 ** 
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 ** 
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 ** 02111-1307, USA.
 **/
#include "main.h"
#include "properties.h"

GtkWidget *width;
GtkWidget *icon_size;

GtkShadowType menustatus = 0;

void menu1(GtkMenuItem * menuitem, gpointer user_data);
void menu2(GtkMenuItem * menuitem, gpointer user_data);
void menu3(GtkMenuItem * menuitem, gpointer user_data);
void menu4(GtkMenuItem * menuitem, gpointer user_data);
void menu5(GtkMenuItem * menuitem, gpointer user_data);

void properties_dialog_clicked(GnomeDialog * dlg, int button, gpointer data);

void doproperties(AppletWidget * l, gpointer m)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *label2;
	GtkWidget *label3;
	GtkWidget *table;
	GtkWidget *menu;
	GtkWidget *optionmenu;
	GtkWidget *menuitem;
	GtkObject *adjustment;
	GtkObject *adjustment2;

	menustatus = config->shadow_type;

	dialog = gnome_dialog_new("Properties",
				  GNOME_STOCK_BUTTON_OK,
				  GNOME_STOCK_BUTTON_APPLY,
				  GNOME_STOCK_BUTTON_CLOSE, NULL);

	gtk_signal_connect(GTK_OBJECT(dialog), "clicked",
			   GTK_SIGNAL_FUNC(properties_dialog_clicked), NULL);

	/* Adjustments for the spin buttons */
	adjustment = gtk_adjustment_new(config->width, 10, 700, 1, 10, 10);
	adjustment2 =
	    gtk_adjustment_new(config->icon_size, 10, 700, 1, 10, 10);

	/* The table that is used to organize the widgets. */
	table = gtk_table_new(1, 1, FALSE);
	gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox), table,
			   FALSE, FALSE, 0);

	/*  menu stuff item factory would probably be easier here
	 *  but this works and I don't see a reason to change it
	 *  create the menu for the select widget */
	menu = gtk_menu_new();
	menuitem = gtk_menu_item_new_with_label("None");
	gtk_widget_show(menuitem);
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
			   GTK_SIGNAL_FUNC(menu1), NULL);
	
	menuitem = gtk_menu_item_new_with_label("Shadow");
	gtk_widget_show(menuitem);
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
			   GTK_SIGNAL_FUNC(menu3), NULL);

	menuitem = gtk_menu_item_new_with_label("Etched");
	gtk_widget_show(menuitem);
	gtk_menu_append(GTK_MENU(menu), menuitem);
	gtk_signal_connect(GTK_OBJECT(menuitem), "activate",
			   GTK_SIGNAL_FUNC(menu5), NULL);

	optionmenu = gtk_option_menu_new();
	gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu), menu);

	gtk_option_menu_set_history(GTK_OPTION_MENU(optionmenu),
				    (config->shadow_type+1)/2);
	gtk_table_attach_defaults(GTK_TABLE(table), optionmenu, 1, 2, 2, 3);

	/* spin buttons go here */
	width = gtk_spin_button_new(GTK_ADJUSTMENT(adjustment), 1, 0);
	gtk_table_attach_defaults(GTK_TABLE(table), width, 1, 2, 0, 1);

	icon_size = gtk_spin_button_new(GTK_ADJUSTMENT(adjustment2), 1, 0);
	gtk_table_attach_defaults(GTK_TABLE(table), icon_size, 1, 2, 1, 2);

	/* labels go here */
	gtk_table_attach_defaults(GTK_TABLE(table),
				  label = gtk_label_new("Applet Width"),
				  0, 1, 0, 1);

	gtk_table_attach_defaults(GTK_TABLE(table),
				  label2 = gtk_label_new("Icon Size"),
				  0, 1, 1, 2);

	gtk_table_attach_defaults(GTK_TABLE(table),
				  label3 = gtk_label_new("Border Type"),
				  0, 1, 2, 3);

	/* show all the crap here */
	gtk_widget_show(menu);
	gtk_widget_show(optionmenu);
	gtk_widget_show(label3);
	gtk_widget_show(label2);
	gtk_widget_show(label);
	gtk_widget_show(table);
	gtk_widget_show(icon_size);
	gtk_widget_show(width);
	gtk_widget_show(dialog);
}

void properties_dialog_clicked(GnomeDialog * dlg, int button, gpointer data)
{

	if (button == 0 || button == 1) {
		config->width =
		    gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(width));
		config->icon_size =
		    gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON
						     (icon_size));
		config->shadow_type = menustatus;
		gtk_widget_set_usize(GTK_WIDGET(applet), config->width,
				APPLET_WIDGET(applet)->size);
		gtk_frame_set_shadow_type(GTK_FRAME(frame),
					  config->shadow_type);
		set_conf(config);
	}
	if (button == 0 || button == 2) {
		gtk_widget_destroy(GTK_WIDGET(dlg));
	}
}

void menu1(GtkMenuItem * menuitem, gpointer user_data)
{
	menustatus = GTK_SHADOW_NONE;
}

void menu2(GtkMenuItem * menuitem, gpointer user_data)
{
	menustatus = GTK_SHADOW_IN;
}

void menu3(GtkMenuItem * menuitem, gpointer user_data)
{
	menustatus = GTK_SHADOW_OUT;
}

void menu4(GtkMenuItem * menuitem, gpointer user_data)
{
	menustatus = GTK_SHADOW_ETCHED_IN;
}

void menu5(GtkMenuItem * menuitem, gpointer user_data)
{
	menustatus = GTK_SHADOW_ETCHED_OUT;
}
